/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.2.1(0e81224179fbb8f6fda18ca7362d8500a263cfef)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
define("vs/languages/typescript/common/tokenization",["require","exports","vs/languages/typescript/common/lib/typescriptServices"],function(e,t,n){"use strict";function o(e){var t=n.createClassifier(),o=e===s.TypeScript?c:l,i=e===s.TypeScript?u:p;return{getInitialState:function(){return new a(e,n.EndOfLineState.None,!1)},tokenize:function(e,n){return r(o,i,t,n,e)}}}function r(e,t,o,r,c){function u(e,t){0!==l.tokens.length&&l.tokens[l.tokens.length-1].scopes===t||l.tokens.push({startIndex:e,scopes:t})}var l={tokens:[],endState:new a(r.language,n.EndOfLineState.None,!1)},p=r.language===s.TypeScript;if(!p&&i(0,c,u))return l;var m=o.getClassificationsForLine(c,r.eolState,!0),d=0;l.endState.eolState=m.finalLexState,l.endState.inJsDocComment=m.finalLexState===n.EndOfLineState.InMultiLineCommentTrivia&&(r.inJsDocComment||/\/\*\*.*$/.test(c));for(var f=0,g=m.entries;f<g.length;f++){var h,y=g[f];if(y.classification===n.TokenClass.Punctuation){var v=c.charCodeAt(d);h=e[v]||t[y.classification],u(d,h)}else y.classification===n.TokenClass.Comment?l.endState.inJsDocComment||/\/\*\*.*\*\//.test(c.substr(d,y.length))?u(d,p?"comment.doc.ts":"comment.doc.js"):u(d,p?"comment.ts":"comment.js"):u(d,t[y.classification]||"");d+=y.length}return l}function i(e,t,n){return 0===t.indexOf("#!")?(n(e,"comment.shebang"),!0):void 0}!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(t.Language||(t.Language={}));var s=t.Language;t.createTokenizationSupport2=o;var a=function(){function e(e,t,n){this.language=e,this.eolState=t,this.inJsDocComment=n}return e.prototype.clone=function(){return new e(this.language,this.eolState,this.inJsDocComment)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.eolState!==t.eolState?!1:this.inJsDocComment===t.inJsDocComment:!1},e}(),c=Object.create(null);c["(".charCodeAt(0)]="delimiter.parenthesis.ts",c[")".charCodeAt(0)]="delimiter.parenthesis.ts",c["{".charCodeAt(0)]="delimiter.bracket.ts",c["}".charCodeAt(0)]="delimiter.bracket.ts",c["[".charCodeAt(0)]="delimiter.array.ts",c["]".charCodeAt(0)]="delimiter.array.ts";var u=Object.create(null);u[n.TokenClass.Identifier]="identifier.ts",u[n.TokenClass.Keyword]="keyword.ts",u[n.TokenClass.Operator]="delimiter.ts",u[n.TokenClass.Punctuation]="delimiter.ts",u[n.TokenClass.NumberLiteral]="number.ts",u[n.TokenClass.RegExpLiteral]="regexp.ts",u[n.TokenClass.StringLiteral]="string.ts";var l=Object.create(null);l["(".charCodeAt(0)]="delimiter.parenthesis.js",l[")".charCodeAt(0)]="delimiter.parenthesis.js",l["{".charCodeAt(0)]="delimiter.bracket.js",l["}".charCodeAt(0)]="delimiter.bracket.js",l["[".charCodeAt(0)]="delimiter.array.js",l["]".charCodeAt(0)]="delimiter.array.js";var p=Object.create(null);p[n.TokenClass.Identifier]="identifier.js",p[n.TokenClass.Keyword]="keyword.js",p[n.TokenClass.Operator]="delimiter.js",p[n.TokenClass.Punctuation]="delimiter.js",p[n.TokenClass.NumberLiteral]="number.js",p[n.TokenClass.RegExpLiteral]="regexp.js",p[n.TokenClass.StringLiteral]="string.js"}),define("vs/languages/typescript/common/typescript",["require","exports","vs/base/common/event","vs/base/common/errors","vs/languages/typescript/common/lib/typescriptServices"],function(e,t,n,o,r){"use strict";var i=function(){function e(e,t){this._onDidChange=new n.Emitter,this._extraLibs=Object.create(null),this.setCompilerOptions(e),this.setDiagnosticsOptions(t)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"extraLibs",{get:function(){return Object.freeze(this._extraLibs)},enumerable:!0,configurable:!0}),e.prototype.addExtraLib=function(e,t){var n=this;if("undefined"==typeof t&&(t="ts:extralib-"+Date.now()),this._extraLibs[t])throw new Error(t+" already a extra lib");return this._extraLibs[t]=e,this._onDidChange.fire(this),{dispose:function(){delete n._extraLibs[t]&&n._onDidChange.fire(n)}}},Object.defineProperty(e.prototype,"compilerOptions",{get:function(){return this._compilerOptions},enumerable:!0,configurable:!0}),e.prototype.setCompilerOptions=function(e){this._compilerOptions=e||Object.create(null),this._onDidChange.fire(this)},Object.defineProperty(e.prototype,"diagnosticsOptions",{get:function(){return this._diagnosticsOptions},enumerable:!0,configurable:!0}),e.prototype.setDiagnosticsOptions=function(e){this._diagnosticsOptions=e||Object.create(null),this._onDidChange.fire(this)},e}();t.LanguageServiceDefaults=i,t.typeScriptDefaults=new i({allowNonTsExtensions:!0,target:r.ScriptTarget.Latest},{noSemanticValidation:!1,noSyntaxValidation:!1}),t.javaScriptDefaults=new i({allowNonTsExtensions:!0,allowJs:!0,target:r.ScriptTarget.Latest},{noSemanticValidation:!0,noSyntaxValidation:!1});var s=function(){function e(){}return e.prototype.acceptNewModel=function(e){throw o.notImplemented()},e.prototype.acceptModelChanged=function(e,t){throw o.notImplemented()},e.prototype.acceptRemovedModel=function(e){throw o.notImplemented()},e.prototype.acceptDefaults=function(e,t){throw o.notImplemented()},e.prototype.getSyntacticDiagnostics=function(e){throw o.notImplemented()},e.prototype.getSemanticDiagnostics=function(e){throw o.notImplemented()},e.prototype.getCompletionsAtPosition=function(e,t){throw o.notImplemented()},e.prototype.getCompletionEntryDetails=function(e,t,n){throw o.notImplemented()},e.prototype.getSignatureHelpItems=function(e,t){throw o.notImplemented()},e.prototype.getQuickInfoAtPosition=function(e,t){throw o.notImplemented()},e.prototype.getOccurrencesAtPosition=function(e,t){throw o.notImplemented()},e.prototype.getDefinitionAtPosition=function(e,t){throw o.notImplemented()},e.prototype.getReferencesAtPosition=function(e,t){throw o.notImplemented()},e.prototype.getNavigationBarItems=function(e){throw o.notImplemented()},e.prototype.getFormattingEditsForDocument=function(e,t){throw o.notImplemented()},e.prototype.getFormattingEditsForRange=function(e,t,n,r){throw o.notImplemented()},e.prototype.getFormattingEditsAfterKeystroke=function(e,t,n,r){throw o.notImplemented()},e.prototype.getEmitOutput=function(e){throw o.notImplemented()},e}();t.TypeScriptWorkerProtocol=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/languages/typescript/common/languageFeatures",["require","exports","vs/base/common/winjs.base","vs/base/common/uri","vs/base/common/severity","vs/base/common/lifecycle","vs/editor/common/modes","vs/editor/common/modes/languageSelector","vs/languages/typescript/common/lib/typescriptServices","vs/base/common/async"],function(e,t,n,o,r,i,s,a,c,u){"use strict";function l(e,t,n,o,r){var a=[];return a.push(s.SuggestRegistry.register(n,new d(e,r),!0)),a.push(s.SignatureHelpProviderRegistry.register(n,new f(e,r),!0)),a.push(s.HoverProviderRegistry.register(n,new g(e,r),!0)),a.push(s.DocumentHighlightProviderRegistry.register(n,new h(e,r),!0)),a.push(s.DefinitionProviderRegistry.register(n,new y(e,r),!0)),a.push(s.ReferenceProviderRegistry.register(n,new v(e,r),!0)),a.push(s.DocumentSymbolProviderRegistry.register(n,new S(e,r),!0)),a.push(s.DocumentRangeFormattingEditProviderRegistry.register(n,new C(e,r),!0)),a.push(s.OnTypeFormattingEditProviderRegistry.register(n,new w(e,r),!0)),a.push(new m(o,n,t,e,r)),i.combinedDisposable(a)}t.register=l;var p=function(){function e(e,t){this._modelService=e,this._worker=t}return e.prototype._positionToOffset=function(e,t){for(var n=this._modelService.getModel(e),o=t.column-1,r=1;r<t.lineNumber;r++)o+=n.getLineContent(r).length+n.getEOL().length;return o},e.prototype._offsetToPosition=function(e,t){for(var n=this._modelService.getModel(e),o=1;;){var r=n.getLineContent(o).length+n.getEOL().length;if(r>t)break;t-=r,o++}return{lineNumber:o,column:1+t}},e.prototype._textSpanToRange=function(e,t){var n=this._offsetToPosition(e,t.start),o=this._offsetToPosition(e,t.start+t.length),r=n.lineNumber,i=n.column,s=o.lineNumber,a=o.column;return{startLineNumber:r,startColumn:i,endLineNumber:s,endColumn:a}},e}(),m=function(e){function t(t,n,o,r,i){var s=this;e.call(this,r,i),this._defaults=t,this._selector=n,this._markerService=o,this._disposables=[],this._listener=Object.create(null);var c=function(e){if(a["default"](n,e.uri,e.getModeId())){var t;s._listener[e.uri.toString()]=e.onDidChangeContent(function(){clearTimeout(t),t=setTimeout(function(){return s._doValidate(e.uri)},500)}),s._doValidate(e.uri)}},u=function(e){delete s._listener[e.uri.toString()]};this._disposables.push(r.onModelAdded(c)),this._disposables.push(r.onModelRemoved(u)),this._disposables.push(r.onModelModeChanged(function(e){u(e.model),c(e.model)})),this._disposables.push({dispose:function(){for(var e in s._listener)s._listener[e].dispose()}}),r.getModels().forEach(c)}return __extends(t,e),t.prototype.dispose=function(){this._disposables=i.dispose(this._disposables)},t.prototype._doValidate=function(e){var t=this;this._worker(e).then(function(o){var r=[];return t._defaults.diagnosticsOptions.noSyntaxValidation||r.push(o.getSyntacticDiagnostics(e.toString())),t._defaults.diagnosticsOptions.noSemanticValidation||r.push(o.getSemanticDiagnostics(e.toString())),n.TPromise.join(r)}).then(function(n){var o=n.reduce(function(e,t){return t.concat(e)},[]).map(function(n){return t._convertDiagnostics(e,n)});t._markerService.changeOne(t._selector,e,o)}).done(void 0,function(e){console.error(e)})},t.prototype._convertDiagnostics=function(e,t){var n=this._offsetToPosition(e,t.start),o=n.lineNumber,i=n.column,s=this._offsetToPosition(e,t.start+t.length),a=s.lineNumber,u=s.column;return{severity:r["default"].Error,startLineNumber:o,startColumn:i,endLineNumber:a,endColumn:u,message:c.flattenDiagnosticMessageText(t.messageText,"\n")}},t}(p),d=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),Object.defineProperty(t.prototype,"triggerCharacters",{get:function(){return["."]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"shouldAutotriggerSuggest",{get:function(){return!0},enumerable:!0,configurable:!0}),t.prototype.provideCompletionItems=function(e,n,o){var r=e.getWordUntilPosition(n),i=e.uri,s=this._positionToOffset(i,n);return u.wireCancellationToken(o,this._worker(i).then(function(e){return e.getCompletionsAtPosition(i.toString(),s)}).then(function(e){if(e){var n=e.entries.map(function(e){return{label:e.name,codeSnippet:e.name,type:t.asType(e.kind)}});return[{currentWord:r&&r.word,suggestions:n}]}}))},t.prototype.resolveCompletionItem=function(e,n,o,r){var i=this,s=e.uri;return u.wireCancellationToken(r,this._worker(s).then(function(e){return e.getCompletionEntryDetails(s.toString(),i._positionToOffset(s,n),o.label)}).then(function(e){return e?{label:e.name,codeSnippet:e.name,type:t.asType(e.kind),typeLabel:c.displayPartsToString(e.displayParts),documentationLabel:c.displayPartsToString(e.documentation)}:o}))},t.asType=function(e){switch(e){case"getter":case"setting":case"constructor":case"method":case"property":return"property";case"function":case"local function":return"function";case"class":return"class";case"interface":return"interface"}return"variable"},t}(p),f=function(e){function t(){e.apply(this,arguments),this.signatureHelpTriggerCharacters=["(",","]}return __extends(t,e),t.prototype.provideSignatureHelp=function(e,t,n){var o=this,r=e.uri;return u.wireCancellationToken(n,this._worker(r).then(function(e){return e.getSignatureHelpItems(r.toString(),o._positionToOffset(r,t))}).then(function(e){if(e){var t={activeSignature:e.selectedItemIndex,activeParameter:e.argumentIndex,signatures:[]};return e.items.forEach(function(e){var n={label:"",documentation:null,parameters:[]};n.label+=c.displayPartsToString(e.prefixDisplayParts),e.parameters.forEach(function(t,o,r){var i=c.displayPartsToString(t.displayParts),s={label:i,documentation:c.displayPartsToString(t.documentation)};n.label+=i,n.parameters.push(s),o<r.length-1&&(n.label+=c.displayPartsToString(e.separatorDisplayParts))}),n.label+=c.displayPartsToString(e.suffixDisplayParts),t.signatures.push(n)}),t}}))},t}(p),g=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideHover=function(e,t,n){var o=this,r=e.uri;return u.wireCancellationToken(n,this._worker(r).then(function(e){return e.getQuickInfoAtPosition(r.toString(),o._positionToOffset(r,t))}).then(function(e){return e?{range:o._textSpanToRange(r,e.textSpan),htmlContent:[{text:c.displayPartsToString(e.displayParts)}]}:void 0}))},t}(p),h=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideDocumentHighlights=function(e,t,n){var o=this,r=e.uri;return u.wireCancellationToken(n,this._worker(r).then(function(e){return e.getOccurrencesAtPosition(r.toString(),o._positionToOffset(r,t))}).then(function(e){return e?e.map(function(e){return{range:o._textSpanToRange(r,e.textSpan),kind:e.isWriteAccess?s.DocumentHighlightKind.Write:s.DocumentHighlightKind.Text}}):void 0}))},t}(p),y=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideDefinition=function(e,t,n){var r=this,i=e.uri;return u.wireCancellationToken(n,this._worker(i).then(function(e){return e.getDefinitionAtPosition(i.toString(),r._positionToOffset(i,t))}).then(function(e){if(e){for(var t=[],n=0,i=e;n<i.length;n++){var s=i[n],a=o["default"].parse(s.fileName);r._modelService.getModel(a)&&t.push({uri:a,range:r._textSpanToRange(a,s.textSpan)})}return t}}))},t}(p),v=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideReferences=function(e,t,n,r){var i=this,s=e.uri;return u.wireCancellationToken(r,this._worker(s).then(function(e){return e.getReferencesAtPosition(s.toString(),i._positionToOffset(s,t))}).then(function(e){if(e){for(var t=[],n=0,r=e;n<r.length;n++){var s=r[n],a=o["default"].parse(s.fileName);i._modelService.getModel(a)&&t.push({uri:a,range:i._textSpanToRange(a,s.textSpan)})}return t}}))},t}(p),S=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideDocumentSymbols=function(e,t){var n=e.uri;return u.wireCancellationToken(t,this._worker(n).then(function(e){return e.getNavigationBarItems(n.toString())}).then(function(e){function t(e,o,r){var i={name:o.text,kind:_[o.kind]||s.SymbolKind.Variable,location:{uri:n,range:this._textSpanToRange(n,o.spans[0])},containerName:r};if(o.childItems&&o.childItems.length>0)for(var a=0,c=o.childItems;a<c.length;a++){var u=c[a];t(e,u,i.name)}e.push(i)}if(e){var o=[];return e.forEach(function(e){return t(o,e)}),o}}))},t}(p),b=function(){function e(){}return e.unknown="",e.keyword="keyword",e.script="script",e.module="module",e["class"]="class",e["interface"]="interface",e.type="type",e["enum"]="enum",e.variable="var",e.localVariable="local var",e["function"]="function",e.localFunction="local function",e.memberFunction="method",e.memberGetAccessor="getter",e.memberSetAccessor="setter",e.memberVariable="property",e.constructorImplementation="constructor",e.callSignature="call",e.indexSignature="index",e.constructSignature="construct",e.parameter="parameter",e.typeParameter="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e["const"]="const",e.let="let",e.warning="warning",e}();t.Kind=b;var _=Object.create(null);_[b.module]=s.SymbolKind.Module,_[b["class"]]=s.SymbolKind.Class,_[b["enum"]]=s.SymbolKind.Enum,_[b["interface"]]=s.SymbolKind.Interface,_[b.memberFunction]=s.SymbolKind.Method,_[b.memberVariable]=s.SymbolKind.Property,_[b.memberGetAccessor]=s.SymbolKind.Property,_[b.memberSetAccessor]=s.SymbolKind.Property,_[b.variable]=s.SymbolKind.Variable,_[b["const"]]=s.SymbolKind.Variable,_[b.localVariable]=s.SymbolKind.Variable,_[b.variable]=s.SymbolKind.Variable,_[b["function"]]=s.SymbolKind.Function,_[b.localFunction]=s.SymbolKind.Function;var T=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t._convertOptions=function(e){return{ConvertTabsToSpaces:e.insertSpaces,TabSize:e.tabSize,IndentSize:e.tabSize,IndentStyle:c.IndentStyle.Smart,NewLineCharacter:"\n",InsertSpaceAfterCommaDelimiter:!0,InsertSpaceAfterFunctionKeywordForAnonymousFunctions:!1,InsertSpaceAfterKeywordsInControlFlowStatements:!1,InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!0,InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!0,InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!0,InsertSpaceAfterSemicolonInForStatements:!1,InsertSpaceBeforeAndAfterBinaryOperators:!0,PlaceOpenBraceOnNewLineForControlBlocks:!1,PlaceOpenBraceOnNewLineForFunctions:!1}},t.prototype._convertTextChanges=function(e,t){return{text:t.newText,range:this._textSpanToRange(e,t.span)}},t}(p),C=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.provideDocumentRangeFormattingEdits=function(e,t,n,o){var r=this,i=e.uri;return u.wireCancellationToken(o,this._worker(i).then(function(e){return e.getFormattingEditsForRange(i.toString(),r._positionToOffset(i,{lineNumber:t.startLineNumber,column:t.startColumn}),r._positionToOffset(i,{lineNumber:t.endLineNumber,column:t.endColumn}),T._convertOptions(n))}).then(function(e){return e?e.map(function(e){return r._convertTextChanges(i,e)}):void 0}))},t}(T),w=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),Object.defineProperty(t.prototype,"autoFormatTriggerCharacters",{get:function(){return[";","}","\n"]},enumerable:!0,configurable:!0}),t.prototype.provideOnTypeFormattingEdits=function(e,t,n,o,r){var i=this,s=e.uri;return u.wireCancellationToken(r,this._worker(s).then(function(e){return e.getFormattingEditsAfterKeystroke(s.toString(),i._positionToOffset(s,t),n,T._convertOptions(o))}).then(function(e){return e?e.map(function(e){return i._convertTextChanges(s,e)}):void 0}))},t}(T)}),define("vs/languages/typescript/common/workerManager",["require","exports","vs/base/common/lifecycle","vs/base/worker/defaultWorkerFactory","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorWorkerServiceImpl","./typescript"],function(e,t,n,o,r,i,s){"use strict";function a(e,t){return new c(t,e)}var c=function(){function e(e,t){this._client=null,this._clientDispose=[],this._factory=new o.DefaultWorkerFactory,this._modelService=e,this._defaults=t}return e.prototype._createClient=function(){var e=this,t=new r.SimpleWorkerClient(this._factory,"vs/languages/typescript/common/worker",s.TypeScriptWorkerProtocol),o=new i.EditorModelManager(t.get(),this._modelService,!0);this._clientDispose.push(o),this._clientDispose.push(t);var a=function(){e._clientDispose=n.dispose(e._clientDispose),e._client=null},c=setInterval(function(){Date.now()-t.getLastRequestTimestamp()>6e4&&a()},6e4);this._clientDispose.push({dispose:function(){clearInterval(c)}}),this._clientDispose.push(this._defaults.onDidChange(function(){return a()}));var u=t.get(),l=this._defaults,p=l.compilerOptions,m=l.extraLibs;return u.acceptDefaults(p,m).then(function(){return{worker:u,manager:o}})},e.prototype.dispose=function(){this._clientDispose=n.dispose(this._clientDispose),this._client=null},e.prototype.getLanguageServiceWorker=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return this._client||(this._client=this._createClient()),this._client.then(function(t){return t.manager.withSyncedResources(e).then(function(e){return t.worker})})},e}();t.create=a}),define("vs/languages/typescript/common/mode",["require","exports","vs/editor/common/modes","vs/languages/typescript/common/tokenization","vs/editor/common/modes/abstractMode","vs/editor/common/modes/supports/richEditSupport","vs/editor/common/services/modelService","vs/editor/common/services/modeService","vs/platform/markers/common/markers","./typescript","./languageFeatures","vs/languages/typescript/common/workerManager"],function(e,t,n,o,r,i,s,a,c,u,l,p){"use strict";function m(e,t,n,r,i,s){var a=[],c=p.create(r,e);a.push(c);var u=l.register(e,t,i,r,function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return c.getLanguageServiceWorker.apply(c,[e].concat(t))});a.push(u),a.push(n.registerRichEditSupport(i,g)),a.push(n.registerTokenizationSupport2(i,o.createTokenizationSupport2(s)))}function d(e){return new i.RichEditSupport(e,null,g)}function f(e){if(!h){h=!0;var t=e.get(s.IModelService),n=e.get(c.IMarkerService),r=e.get(a.IModeService);m(t,n,r,u.typeScriptDefaults,"typescript",o.Language.TypeScript),m(t,n,r,u.javaScriptDefaults,"javascript",o.Language.EcmaScript5)}}var g={wordPattern:r.createWordRegExp("$"),comments:{lineComment:"//",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],onEnterRules:[{beforeText:/^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,afterText:/^\s*\*\/$/,action:{indentAction:n.IndentAction.IndentOutdent,appendText:" * "}},{beforeText:/^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,action:{indentAction:n.IndentAction.None,appendText:" * "}},{beforeText:/^(\t|(\ \ ))*\ \*(\ ([^\*]|\*(?!\/))*)?$/,action:{indentAction:n.IndentAction.None,appendText:"* "}},{beforeText:/^(\t|(\ \ ))*\ \*\/\s*$/,action:{indentAction:n.IndentAction.None,removeText:1}},{beforeText:/^(\t|(\ \ ))*\ \*[^\/]*\*\/\s*$/,action:{indentAction:n.IndentAction.None,removeText:1}}],__electricCharacterSupport:{docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}},autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`"}]};t.createRichEditSupport=d;var h=!1;t.activate=f});
//# sourceMappingURL=../../../../../min-maps/vs/languages/typescript/common/mode.js.map